hdu 5335 Walk Out (搜索)

题目链接:

  hdu 5335 Walk Out

题目描述:
  有一个n*m由0 or 1组成的矩形,探险家要从(1,1)走到(n, m),可以向上下左右四个方向走,但是探险家就是不走寻常路,他想让他所走的路线上的0/1组成的二进数最小,现在要为矫情无比的探险家找最优路径咯。

解题思路:
  对于二进制数,前导零是对数字大小没有任何影响的。当到不得不走1的时候就只能向下,或者向右走了。所以先搜索出来一直走零,能走到的最靠近终点的位置,然后在类似搜索,找出最优路径。

 1 #include <queue>
 2 #include <cstdio>
 3 #include <cstring>
 4 #include <iostream>
 5 #include <algorithm>
 6 using namespace std;
 7 const int maxn = 1010;
 8 struct node
 9 {
10     int x, y;
11 };
12 char maps[maxn][maxn];
13 bool vis[maxn][maxn];
14 int dir[4][2] = {1,0, 0,1, -1,0, 0,-1};
15 int x, y, n, m;
16 bool Ok (int x, int y)
17 {
18     if (x<0 || y<0 || x>=n || y>=m)
19         return false;
20     return true;
21 }
22 void bfs ()
23 {
24     node p, q;
25     p.x = x, p.y = y;
26     queue <node> Q;
27     Q.push (p);
28     while (!Q.empty())
29     {
30         p = Q.front();
31         Q.pop();
32         for (int i=0; i<4; i++)
33         {
34             q.x = p.x + dir[i][0];
35             q.y = p.y + dir[i][1];
36             if (Ok(q.x, q.y) && !vis[q.x][q.y])
37             {
38                 vis[q.x][q.y] = true;
39                 if (maps[q.x][q.y] == ‘0‘)
40                     Q.push (q);
41                 if (x + y < q.x + q.y)
42                     x = q.x, y = q.y;
43             }
44         }
45     }
46 }
47 int main ()
48 {
49     int t;
50     scanf ("%d", &t);
51     while (t --)
52     {
53         memset (vis, false, sizeof(vis));
54         vis[0][0] = true;
55         scanf ("%d %d", &n, &m);
56         for (int i=0; i<n; i++)
57             scanf ("%s", maps[i]);
58         x = y = 0;
59         if (maps[x][y] == ‘0‘)
60             bfs ();
61         if (maps[x][y] == ‘0‘)
62             putchar(‘0‘);
63         else
64         {
65             bool nowflag = false;
66             putchar (‘1‘);
67             for (int i=x+y; i<n+m-2; i++)
68             {
69                 bool flag = false;
70                 for (x=0; x<=i; x++)
71                 {
72                     y = i - x;
73                     if (!Ok(x, y) || !vis[x][y])
74                         continue;
75                     if (nowflag && maps[x][y]==‘1‘)
76                         continue;
77                     for (int j=0; j<2; j++)
78                     {
79                         int a = x + dir[j][0];
80                         int b = y + dir[j][1];
81                         if (!Ok(a, b))
82                             continue;
83                         vis[a][b] = true;
84                         if (maps[a][b] == ‘0‘)
85                             flag = true;
86                      }
87                 }
88                 nowflag = flag;
89                 putchar (flag?‘0‘:‘1‘);
90             }
91         }
92         puts("");
93     }
94     return 0;
95 }
时间: 2024-11-06 14:36:35

hdu 5335 Walk Out (搜索)的相关文章

HDU 5335 Walk Out (搜索+贪心,超详解)经典

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=5335 题面: Walk Out Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Total Submission(s): 2355    Accepted Submission(s): 459 Problem Description In an n?m maze, the righ

HDU 5335 Walk Out(Bfs搜索字典序最小的最短路)

 题意:nXm的地图, 问通过四个方向从(1,1)走到(1000,1000)所经过的最小二进制序列是多少,忽略前缀0. 思路:首先如果起点为0,那么我们bfs搜索和起点0联通的为0的连通块,这样我们第一步肯定是从与这个连通块相邻的且与重点最近的地方出发. 将所有可能起点加入队列,在bfs一遍找到字典序最小的那条路就是答案, 在这里可以用两个vector类型容器,一个是q2存储所有节点值存为0的结点, 另一个q3存储节点值为1的结点. 那么如果q2不为空那么也就是有可以走零,那么就从这里面选,

HDU 5335 Walk Out(多校)

Walk Out Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)Total Submission(s): 2912    Accepted Submission(s): 599 Problem Description In an n∗m maze, the right-bottom corner is the exit (position (n,m) is the exit).

HDU 5335——Walk Out——————【贪心】

Walk Out Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)Total Submission(s): 1292    Accepted Submission(s): 239 Problem Description In an n∗m maze, the right-bottom corner is the exit (position (n,m) is the exit).

HDU 5335 Walk Out

题意:在一个只有0和1的矩阵里,从左上角走到右下角, 每次可以向四个方向走,每个路径都是一个二进制数,求所有路径中最小的二进制数. 解法:先bfs求从起点能走到离终点最近的0,那么从这个点起只向下或向右走就可以获得位数最少的二进制数,然后贪心的想,如果后或下有0就一定走0,没0就把1都看一遍,以之前搜到的0做起点,一层一层遍历可行路径,直到终点. 代码: #include<stdio.h> #include<iostream> #include<algorithm> #

HDU 5335 Walk Out (BFS,技巧)

题意:有一个n*m的矩阵,每个格子中有一个数字,或为0,或为1.有个人要从(1,1)到达(n,m),要求所走过的格子中的数字按先后顺序串起来后,用二进制的判断大小方法,让这个数字最小.前缀0不需要输出!! 思路:主要考虑的是BFS解决. 如果grid[1,1]=1,那么这个二进制的位数也就定下来了,是n+m-1,很好解决,每个格子就只能往下或者往右,否则长度一定超过n+m+1,必定不是最优. 如果grid[1,1]=0,那么可能会出现绕了一个S型到终点的结果为0而已.所以不能用老办法,要先预处理

hdu 5335 Walk Out(bfs+寻找路径)

Problem Description In an n∗m maze, the right-bottom corner is the exit (position (n,m) is the exit). In every position of this maze, there is either a 0 or a 1 written on it. An explorer gets lost in this grid. His position now is (1,1), and he want

HDU 5335 多校第4场 1009 Walk Out

Walk Out Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others) Total Submission(s): 1794    Accepted Submission(s): 340 Problem Description In an n?m maze, the right-bottom corner is the exit (position (n,m) is the exit)

HDU 5001 Walk(鞍山网络赛E题)

HDU 5001 Walk 题目链接 思路:枚举每个要经过的点,然后进行状态转移,状态为dp[i][j],状态表示当前在j的点,已经走了i步,每次转移的时候,不从这个枚举的点出发,这样就可以求出所有路径经过该点的概率p, 然后1 - p就是不经过的答案 代码: #include <cstdio> #include <cstring> #include <vector> #include <algorithm> using namespace std; con